/*
 *
 * File: IECavityElement.java
 * Date: Jan 27, 2008; 5:47:42 PM
 */
package de.desy.mst.libs.accelerator.model.cavity;

import de.desy.mst.libs.accelerator.IEData;

/**
 * This is the cavity element for viewing on screen and determines its position
 * according to its unique enumeration value. Currently this interface doesn't
 * contain any method and is therefore only responsible as a naming for the
 * concrete class.
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: IECavityElement.java 19598 2008-12-10 11:22:25Z walla $
 */
public interface IECavityElement extends IEData {
}
/* end of file */