/*
 * Created on 	Mar  8, 2005 - Jul 12, 2005
 * 				Oct 25, 2005 - Nov. 3, 2005
 * 				Fet 07, 2006				varargs statt string start parameter
 * 				Mai 08, 2006				ws: createMstFrameMainSubClass error Text expliziter
 * 				Jul 18, 2006 - ...			ws: createMstFrameMainSubClass error Text expliziter mit mstApp.getCreationSuccess() Auswertung
 * 				Aug 08, 2006 - ...			ws: added: afterFrameCreated()
 * 				Aug 28, 2006 - ...			ws: added: getLastCreatedFrame() zum Testen fuer MW
 * 				Oct 16, 2006 - Oct 16, 2006	ws:	removed Guilleaumes (-> Markus Walla)
 * 				Jan  1, 2007 - ...			ws:	Main.exit statt objekt.onexit
 * 				Jan  8, 2007 - ...			ws:	main(String ... args) -> main(String ... args)
 * 				Mar 13, 2007 - ...			ws: added:  uncaughtExceptionShowMsgBox
 * 				Mar 19, 2007 - Mar 27, 2007	ws: update: Class -> Class<? extends MstFrame>
 * 												added:  getApplicationInfo()
 * May  3, 2007 - 		ws:	added: Main.nUncaughtExeptions (max 1 MsgBox zeigen)
 * Aug  2, 2007 - Aug  2, 2007	ws: after Frame created im richtigen Thread,
 * 								handle Generics Warnings
 * 								@Override public void run() -> no @Override
 * Aug 24, 2007 - Aug 24, 2007	ws:	add reserveFlashScreen(b)
 * Aug 29, 2007 - Aug 30, 2007 	ws: String appName -> ApplicationInfo appInfo
 * Nov 21, 2007 - Nov 21, 2007	ws: extracted UncaughtExceptionHandler
 * Jan  9, 2008 - Jan 10, 2008	ws:	added: exitInEDT() Handling
 * Jan 30, 2008 - Jan 30, 2008	ws: MstAppKernel gegen crash in
 * 									Uncaught Exception Handler
 * Feb 28, 2008 - Feb 28, 2008	ws: wrap "frameFlash.dispose()" in EDT
 * May  6, 2008 - May  8, 2008	ws: added: _APPSTART, Performance output
 * Jun 13, 2008 - Jun 13, 2008	ws: removed Throwable (Trace) for exit mit status != 0
 * Jul  1, 2008 - Jul  1, 2008	ws: mache lib startbar mit leerem MstFrameMain
 * Jul  7, 2008 - Jul  7, 2008	ws: add here reference to central ExecutorService
 * Sep 22, 2008 - Sep 22, 2008	ws:	guard cancelExit() (MaWa Mail vom 22. Sept)
 * Oct 14, 2008 - Oct 14, 2008	ws:	myRunChoreography() added: LoggerManager.setMstApp(this.mstApp);
 * Oct 20, 2008 - Oct 20, 2008	ws:	Log die Startparameter
 * Nov 26, 2008 - Nov 26, 2008	ws:	OpModeACLEntry.preload(...)
 * Dec  2, 2008 - Dec  2, 2008	ws:	added centerToMstFrameMain(...)
 * Jan  8, 2009 - Jan  8, 2009	ws:	added calcAnnotatedTitle()
 * Jan 15, 2009 - Jan 15, 2009	ws:	fixed: isSubClassOfMstFrameMain(...)
 * Jun 10, 2009 - Jun 22, 2009	ws:	log with Tine Tag, some refactorings
 * Jul 14, 2009 - Jul 14, 2009	ws:	fixed some Eclipse 3.5 warnings
 * Dec 15, 2009 - Dec 15, 2009	ws:	implemented: iniFiles() switch semantics
 * Jan 12, 2010 - Jan 12, 2010	ws: add exit(int, throwable)
 * Mar 18, 2010 - Mar 18, 2010	kh, ws: add look and feel support
 * May  3, 2010 - May  3, 2010	rb, ws: add updateLookAndFeelComponentTree after Frame created
 * Nov 30, 2007 - Nov 30, 2007	ws:	title for flashScreen included
 * Nov 25, 2014 - Nov 25, 2014	kh, ws: nicht doppelt exitInEDT(...)
 * May 28, 2015 - Jun  3, 2015	ws:	add Switches for "mstweb" usage: USE_MSTWEB4ACL, USEMSTWEB4INI
 * Aug 20, 2015 - Aug 20, 2015	ws:	USE_MSTWEB4ACL, USEMSTWEB4INI both to false as needed in service week starting Monday  
 */

package de.desy.mst.libs.framework.mstapp;

import static de.desy.mst.libs.framework.mstapp.logging.LogUtil.timedMsg;

import java.awt.Component;
import java.awt.Image;
import java.awt.Window;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.atomic.AtomicBoolean;

import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UIManager.LookAndFeelInfo;

import de.desy.mst.libs.framework.mstapp.flash.IProgress;
import de.desy.mst.libs.framework.mstapp.flash.MstFrameFlash;
import de.desy.mst.libs.framework.mstapp.flash.Progress;
import de.desy.mst.libs.framework.mstapp.ini.MasterMgrForIniFiles;
import de.desy.mst.libs.framework.mstapp.logging.LMTag;
import de.desy.mst.libs.framework.mstapp.logging.LogLvl;
import de.desy.mst.libs.framework.mstapp.logging.LogMsg;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.logging.LoggerManager;
import de.desy.mst.libs.framework.mstapp.messages.ISetMessage;
import de.desy.mst.libs.framework.mstapp.messages.Message;
import de.desy.mst.libs.framework.mstapp.messages.MessageMgr;
import de.desy.mst.libs.framework.mstapp.mode.Maschine;
import de.desy.mst.libs.framework.mstapp.security.MstSecurity;
import de.desy.mst.libs.framework.mstapp.util.gui.MstImage;

/**
 * The main routine of all standard MSTApp's.
 * It is the main threadgroup.
 * It is responsible for all application life operations like:
 * 		+ Start of application
 * 		+ Base handling of input arguments
 * 		+ end of application
 * It handles "uncaughtException"s in a standard way.
 * Please do not leave this threadgroup in the ancestor chain for new threads.
 *
 * Warum soll Main das Hauptprogramm sein?
 *    - uncaughtException handling
 *    - Initialisierungschoreographie mit flash, frameMain und Init an einer Stelle.
 *    	Insbesondere ist hier fuer MultiThreading ein guter Ansatzpunkt, falls
 *    	Anwendungen lange Initialisierungen haben sollten.
 * Probleme dadurch:
 *    - komplizierteres Handling
 *    - die MstFrameMain Unterklasse kann erst zur Laufzeit und nicht zur
 *      Kompilierzeit erkannt werden. Laufzeitfehler sind unangenehmer als
 *      Kompilierzeitfehler.
 *
 * @author schuette
 * @version Mar 8, 2005
 *
 */
//@SuppressWarnings({"rawtypes"})
public final class Main extends ThreadGroup implements IProgress, ISetMessage{
	public static final long _APPSTART = System.currentTimeMillis();
	public static final MSTWebUsageSettings mstwebUsageSettings = new MSTWebUsageSettings();
	/**full threadsafe place to steer mstweb usage including defaulting*/
	public static class MSTWebUsageSettings {
		private boolean use_mstweb4ACL = false;	//default: OLD WEBACLS NO new tine acls 
		private boolean use_mstweb4ini = false;	//default: OLD mstweb ini files NOT available 
		private boolean isInitialised  = false;
		//.........................................................................................
		MSTWebUsageSettings() {/**pp*/}
		@Deprecated/**only for testing purposes*/ 
		MSTWebUsageSettings(final MSTWebUsageSettings copyFromThis) {
			this(copyFromThis.use_mstweb4ACL, copyFromThis.use_mstweb4ini, copyFromThis.isInitialised);
		}
		private MSTWebUsageSettings(final boolean use_mstweb4ACL, final boolean use_mstweb4ini, final boolean isInitialised) {
			this.use_mstweb4ACL = use_mstweb4ACL;
			this.use_mstweb4ini = use_mstweb4ini;
			this.isInitialised = isInitialised;
		}
		//.........................................................................................
		/**@return the isInitialised, after initialisation no more changing of use vars*/
		public synchronized boolean isInitialised() {return this.isInitialised;}
		/**pp*/synchronized void setInitialised() {this.isInitialised = true;}
		/**@param use_mstweb4ACL change only at very beginning (isInitialized()==false), true: ACLS from legacy mstweb else tine*/
		public synchronized void setUse_mstweb4ACL(final boolean use_mstweb4ACL) {
			if(isInitialised())
				throw new IllegalStateException("Can not change " + this.getClass().getSimpleName() + " after initialisation.");
			this.use_mstweb4ACL = use_mstweb4ACL;
		}
		public synchronized boolean isUse_mstweb4ACL() {return this.use_mstweb4ACL;}
		public synchronized boolean isUse_mstweb4ini() {return this.use_mstweb4ini;}
		/**@param use_mstweb4ini change only at very beginning (isInitialized()==false), true: inifiles from legacy mstweb else no ini std files*/
		public synchronized void setUse_mstweb4ini(final boolean use_mstweb4ini) {
			if(isInitialised())
				throw new IllegalStateException("Can not change " + this.getClass().getSimpleName() + " after initialisation.");
			this.use_mstweb4ini = use_mstweb4ini;
		}
		@Override synchronized public int hashCode() {
			final int prime = 31;
			int result = 1;
			result = prime * result + (this.isInitialised ? 1231 : 1237);
			result = prime * result + (this.use_mstweb4ACL ? 1231 : 1237);
			result = prime * result + (this.use_mstweb4ini ? 1231 : 1237);
			return result;
		}
		@Override synchronized public boolean equals(final Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			final MSTWebUsageSettings other = (MSTWebUsageSettings) obj;
			if (this.isInitialised != other.isInitialised)
				return false;
			if (this.use_mstweb4ACL != other.use_mstweb4ACL)
				return false;
			if (this.use_mstweb4ini != other.use_mstweb4ini)
				return false;
			return true;
		}
		
		//--------------------------------------------
	}//END CLASS: MSTWebUsageSettings
	//.............................................................................................
	private static String lookAndFeel = "Metal";
    /**pp*/ static final String KONSTRUKOR_PROBLEM = "Kann den Java Hauptframe nicht erzeugen (Konstrukor Problem?).";
	private static final String mainTGName = "MSTApp TG";
	private static String mainTreadName = "MSTApp ___ Thread";
	//.............................................................................................
    private final MessageMgr messageMgr = new MessageMgr();

    private MasterMgrForIniFiles masterMgrForIniFiles; //pseudo final, should not be changed
	private MstApp     mstApp;                         //pseudo final, should not be changed
	private IProgress  progressReceiver;               //pseudo final, should not be changed

    private boolean glueFrameMainWasCalled = false; //for call once/object semantic
	private volatile static MstFrameMain lastCreatedFrame  = null;	//zum Debuggen/Testen only
	private volatile static ParamDecoder startParameter;
	private static MstAppKernel mstAppK;

	/**Zentraler MstApp Thread Pool*/
	private static final ExecutorService exec = Executors.newCachedThreadPool();

	/**contains no nulls*/
	private final static List<IOnExit> listOfOnExits =
						Collections.synchronizedList(new ArrayList<IOnExit>());
	private final static AtomicBoolean isExiting = new AtomicBoolean(false);
	/**
	 * Hier werden die Uncaught Exceptions gezaehlt, erste schon toedlich
	 * aber ein anderer Thread (z.B. Tine) kann viele reinpumpen bevor dieses
	 * Programm tatsaechlich beendet ist.
	 */
	private MstFrameFlash frameFlash;

//=============================================================================

/**
 * THE MAIN ENTRY TO MstApp's is here. Please supply a valid MstFrameMain class name.
 * @param args	<li> full qualified mstFrameMainName (inklusive Paketname)
 * 				<li> <b>optionale Parameter folgen:</b>
 * 				<li> ApplikationsName
 * 				<li> Maschine z.B. "PE"
 * 				<li> Weitere Parameter sind Applikations Entwickler
 * 					 Parameter und knnen mit aus dem Entwicklerframe mit
 * 					 getMstApp().getStartParameter().userParameter(int index)
 *  				 index = 0, 1, ... wieder geholt werden.
 */
	public final static void main(String ... args) {
		if(args.length == 0)
			args = new String[] {MstApp11.class.getName(), "mstapp11", Maschine.Am.name()};
		Main.startParameter = new ParamDecoder(args);
		startMSTAppInternal();
	}
	/**Wunsch Josef Wilgen vom 22.11.2007 <br> Parameter siehe Main.main(String ... args)*/
	public final static void startMSTApp(final String mstFrameMainName, final String appName, final String maschinenName, final String[] userParameter){
		Main.startParameter = new ParamDecoder(mstFrameMainName, appName, maschinenName, userParameter);
		startMSTAppInternal();
	}
	/**
	 * @param mstFrameMainName 	name of the MstFrameMain class with packagename included
	 * 							like "de.desy.mst.mstapp.MstFrameMain"
	 * @param args				Start Parameters of the Program other than mstFrameName
	 * 							Sie sind optional.
	 * 							UserParameter kommen nach ApplikationsName und
	 * 							Maschine
	 * @link de.desy.mst.mstapbeispiele.FrameMainBeispiel02
	 */
	public final static void startMSTApp(final String mstFrameMainName, final String ... args) {
		//the decoder takes full responsibility of the startup args
		Main.startParameter = new ParamDecoder(mstFrameMainName, args);
		startMSTAppInternal();
	}


	/**
	 * @param args	startup Parameter der Applikation ohne Klassennamen oder null
	 * @deprecated 	benutze Main.main(args) oder Main.startMSTApp(thisClassName, args);
	 * @link de.desy.mst.mstapbeispiele.FrameMainBeispiel03
	 */
	@Deprecated public final static void startMSTAppAndHackMyClassname(final String[] args){
		final String mstFrameMainName = hackTheName();
		startMSTApp(mstFrameMainName, args);
	}

	public final static String getAppName(){
		return Main.startParameter == null ? "~~~UNKNOWN APPNAME~~~"
										   : Main.startParameter.appName;
	}
	public final static boolean hasApplicationInfo(){
		return Main.startParameter != null;
	}
	@Deprecated public final static ApplicationInfo getApplicationInfo(){
		return Main.startParameter == null
			  ? ApplicationInfo._UNKNOWN_APP_INFO
		      : Main.startParameter.applicationInfo;
	}

	/**nur zum testen!!!*/ @Deprecated
	public synchronized static final MstFrameMain getLastCreatedFrame(){return lastCreatedFrame;}
	/**best guess of MstFrameMain of this app*/
	public static  void centerToMstFrameMain(final Window wnd) {
		wnd.setLocationRelativeTo(Main.getLastCreatedFrame());//best guess of true MstFrameMain
	}
	/**nur zum testen!!!*/ @Deprecated
	public static final void setStartParameter(final ParamDecoder startParameter) {
		Main.startParameter = startParameter;
	}
	/**nur zum testen!!!*/ @Deprecated
	public static final ParamDecoder getStartParameter() {
		return Main.startParameter;
	}

	/**Zentraler MstApp Thread Pool*/
	public static ExecutorService getExecutorService() {return exec;}

	public static String getLookAndFeel() {return lookAndFeel;}
	/**Ganz am anfang setzen, null == default look and feel*/
	public static void setLookAndFeel(final String lookAndFeel) {
		Main.lookAndFeel = lookAndFeel;

		if(lookAndFeel == null)
			return;

		final LookAndFeelInfo laf = getLookAndFeelInfo(lookAndFeel);
		if(laf == null)
			return;

		try {
			UIManager.setLookAndFeel(laf.getClassName());
			Logger.SWFW.info("Look and feel zu '" + lookAndFeel + "' gesetzt.");
		} catch (final Exception ex) {
			Logger.SWFW.warn("Kann das Look and Feel nicht zu '" + lookAndFeel + "' setzen.", ex);
		}
	}

	/**
	 * ReBa proposed enhancement against the Mac JCombo dilemma<br>
	 * not automatically used: it kills ca. 1/3 of mstApp applications on XP
	 */
	public static void updateLookAndFeelComponentTree(final Component component) {
		if(component == null)
			return;
		SwingUtilities.invokeLater(new Runnable(){
			@Override public void run() {
				try{
					SwingUtilities.updateComponentTreeUI(component);
					Logger.SWFW.info("updateLookAndFeelComponentTree() called with success.");
				}catch(final Throwable th){
					Logger.SWFW.warn("updateLookAndFeelComponentTree() called with a problem.", th);
				}
			}
		});
	}
	private static LookAndFeelInfo getLookAndFeelInfo(final String lookAndFeel){
		try {
			for (final LookAndFeelInfo laf : UIManager.getInstalledLookAndFeels() )
				if (lookAndFeel.equals(laf.getName()))
					return laf;
		} catch (final Exception ex) {
			Logger.SWFW.warn("Kann das Look and Feel nicht zu '" + lookAndFeel + "' setzen.", ex);
		}
		Logger.SWFW.warn("Habe das Lookand Feel nicht gefunden '" + lookAndFeel + "'.");
		return null;
	}

//=============================================================================

    /**
     * Constructs a new thread group. The parent of this new group is
     * the thread group of the currently running thread.
     * <p>
     * The <code>checkAccess</code> method of the parent thread group is
     * called with no arguments; this may result in a security exception.
     *
     * @param   name   the name of the new thread group.
     * @exception  SecurityException  if the current thread cannot create a
     *               thread in the specified thread group.
     * @see     java.lang.ThreadGroup#checkAccess()
     * @since   JDK1.0
     */
    public Main(final String name) {super(name);}

//=============================================================================

    /**Applikation wird programmatisch und korrekt beended (mit logging etc.)*/
    public final static void exit(){Main.exit(0);}
    /**Applikation wird programmatisch und korrekt beended (mit logging etc.)<br>
     * status == 0 heisst ok*/
    public final static synchronized void exit(final int status){exit(status, null);}
    /**Applikation wird programmatisch und korrekt beended (mit logging etc.)<br>
     * status == 0 heisst ok
     * falls throwable nicht null wird der crashscreen angezeigt*/
    public final static synchronized void exit(final int status, final Throwable throwable){
    	final Thread t = Thread.currentThread();
    	if(SwingUtilities.isEventDispatchThread()){
    		exitInEDT(status, throwable, t);
    	}else{
    		try {
				SwingUtilities.invokeAndWait(new Runnable(){
					@Override public void run() {exitInEDT(status, throwable, t);}
				});
			} catch (final InterruptedException e) {exit(status);//retry ad infinitum
			} catch (final InvocationTargetException e) {
				Logger.SWFW.error("Problem im Abarbeiten von Main.exit(..)", e);
				exitInEDT(status, throwable, t);	//try ohne EDT Stuff
			}
    	}
    }

	/**
	 * @param status		0 ... ok
	 * @param throwable		null no dialog
	 * @param t				original thread of nonnull throwable
	 */
	private static void exitInEDT(final int status, final Throwable throwable, final Thread t) {
		if(Main.isExiting.get())
			return;//nie doppelt aufrufen sonst thread blocking Gefahr
		if(throwable != null)
			UncaughtExceptionHandler.handleUncaughtException(getMstAppK(), t, throwable);
		Main.isExiting.set(true);	//schuetzt list Iterator
		if(cancelExit()){
			final String msg = "Gewnschtes Programm Ende wurde"
							 + " von der Applikation nicht aktzeptiert.";
			Logger.SWFW.info(msg);
			Main.isExiting.set(false);
			return;
		}
		Main.processListOnExit();

		final LogLvl    logLvl    = (status == 0) ? LogLvl.info : LogLvl.error;
        Logger.doLog(logLvl, Logger.SWFW_, "Status Code: " + status, null);

        Logger.doLog(logLvl, Logger.SWFW_, timedMsg(_APPSTART, "Ende der Applikation"), null, LMTag.NachSrvTineLog);

        LoggerManager.flush();

        System.exit(status);    //the one and only legal exit point
	}
	private static boolean cancelExit() {
		try {
			for (final IOnExit iOnExit : listOfOnExits) {
				if(iOnExit instanceof IOnExit2 && cancelExit((IOnExit2)iOnExit))
					return true;	//abbrechen
			}

		} catch (final Exception ex) {
			final String msg = "Problem with Main.cancelExit() " + ex.getMessage();
			Logger.SWFW.warn(msg, ex);
		}
		return false;
	}
	private static boolean cancelExit(final IOnExit2 iOnExit) {
		try {
			return iOnExit.onBeforeExit();
		} catch (final Exception e) {
			final String msg = "Error on processing application specifig cancelExit.";
			Logger.SWFW.error(msg,e);
			return false;	//cancel nur bei errorfreier Ausfuehrung erlaubt
		}
	}

    /**use Main.exit()*/
    @Deprecated public final void onExit(){Main.exit();}
    /**use Main.exit(status)*/
    @Deprecated public final void onExit(final int status) {Main.exit(status);}

	/**alle registrierten IOnExits werden kurz vor Ende der Applikationslaufzeit aufgerufen*/
	public static final void registerForOnExit(final IOnExit iOnExit){
		if(iOnExit != null){listOfOnExits.add(iOnExit);
		}else{Logger.SWFW.warn(new NullPointerException("Strange use of iOnExit"));}
	}
	/**@return <tt>true</tt> if this list contained the specified element.*/
	public static final boolean deRegisterForOnExit(final IOnExit iOnExit){
		if(Main.isExiting.get())
			return false;	//ignore (zu spaet)
		return listOfOnExits.remove(iOnExit);
	}

//-----------------------------------------------------------------------------

	/* (non-Javadoc)
     * @see de.desy.mst.mstapp.IFlash#onProgress(de.desy.mst.mstapp.Progress)
     */
	@Override public synchronized final void onProgress(final Progress progress) {
        Logger.SWFW.info("Progress = " + progress);
        if(this.progressReceiver != null){
            this.progressReceiver.onProgress(progress);
        }
    }
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.flash.IProgress#reserveFlashScreen(boolean)
	 */
	@Override public synchronized int reserveFlashScreen(final boolean b) {
		final MstFrameFlash frameFlash = getFrameFlash();
		final int nReservations = (frameFlash != null)
								? frameFlash.reserveFlashScreen(b) : -1;

		if(nReservations <= 0){
			if(frameFlash == null){
				final String msg = "Main.reserveFlashScreen("
					 + b
					 + ") aufgerufen nach dispose() des FlashScreens."
					 + " Just ignored.";
				Logger.SWFW.warn(msg);
			}else{
				this.progressReceiver = null;
				setFrameFlash(null);
				SwingUtilities.invokeLater(new Runnable(){
					@Override public void run() {frameFlash.dispose();}
				});
			}
		}
		return nReservations;
	}

    /* (non-Javadoc)
     * @see de.desy.mst.mstapp.messages.ISetMessage#setMessage(java.lang.String, java.lang.String, int)
     */
	@Override public final void setMessage(final Message message) {
        getMessageMgr().setMessage(message);
    }

    /**@return Returns the messageMgr != null and unique*/
    public final MessageMgr getMessageMgr() {
        return this.messageMgr;
    }

    /**@return Returns the iniFileMgr never null and unique.*/
    public final MasterMgrForIniFiles getMasterMgrForIniFiles() {
        final MasterMgrForIniFiles mmfif = this.masterMgrForIniFiles;
		if(mmfif != null)
			return mmfif;
		Logger.SWFW.error(this.getClass().getName() + ".getMasterMgrForIniFiles() would be null so create a synthetic one (should only happen during testing never in production!!!),");
		return new MasterMgrForIniFiles(Main.startParameter.applicationInfo, getMessageMgr());
    }

	/**
	 * Sekundaere Fenster der Applikation sollen eindeutig einer Applikation
	 * mit einem spezifischen Lauf zugeordnet werden koennen (sekundaere
	 * Frames schweben normalerweise ziemlich unverbunden zu der zugehoerigen
	 * Applikation herum)
	 * @param rawTitle
	 * @return Frame Titel mit rawTitle, Applikations Namen und RunId
	 */
	public static String calcAnnotatedTitle(final String rawTitle) {
		return rawTitle + " fr " + getAppName()
						+ " (" + LogMsg.THIS_RUN_RUNID + ")";
	}

//=============================================================================

    /**
     * Package private, system use only.
     * No more than one access per object permitted and
     * only under special circumstances. <br>
     * Reason d'etre:<br>
     * strange initialisation sequence for Eclipse Visual Editor
     * I have to go through the default contructor. <br><br>
     * @throws IllegalStateException second round on initialisation tried
     * @throws NullPointerException, if any argument == null
     */
    final void reverseInit(final MstApp mstApp , final String appName){
        if(this.mstApp != null)    {throw new IllegalStateException("Tried to call reverseInit in initialised state.");}

        if(mstApp == null)   {throw new NullPointerException("mstApp must not be null.");}
        if(appName == null)  {throw new NullPointerException("appName must not be null.");}


        this.mstApp = mstApp;
    }

    /**
     * Package private, system use only. <br>
     * External access only after reverseInit and FrameMain basis initialisation done.<br>
     * @throws IllegalStateException second round on initialisation tried
     * @throws NullPointerException, if frameMain == null
     */
    final void glueFrameMain(final MstFrameMain frameMain) {
        if(this.glueFrameMainWasCalled){throw new IllegalStateException("Tried to call reverseInit in initialised state.");}
        if(frameMain == null)          {throw new NullPointerException("frameMain must not be null.");}

        this.glueFrameMainWasCalled  = true; //and never call it again
        glueFrameMainWithMsgMgr(frameMain, getMessageMgr());
    }

//=============================================================================

	/**
	 * @return 	Hacked-Name der Klasse, die das Programm gestartet hat in der Hoffnung,
	 * 			dass dies eine Unterklasse von MstFrameMain ist.
	 * 			(ganz genau: Thread-Entry-Klassennamen)
	 */
	private final static String hackTheName() {
		String mstFrameMainName;
		final Exception exception = new Exception("Dummy Exception only");
		final StackTraceElement[] elements = exception.getStackTrace();
		StackTraceElement element;

		Class<?> theClass;
		for (int i = 0; i < elements.length; i++) {
			element = elements[i];
			try {
				theClass = Class.forName(element.getClassName());
				if (isSubClassOfMstFrameMain(theClass)){
					return theClass.getName();
				}
			} catch (final ClassNotFoundException ex) {
				Logger.SWFW.fatal("Kann die Hauptform nicht erzeugen", ex);
			}
		}

		//versuch es einfach mit der Root Klasse
		element =  elements[elements.length - 1];
		mstFrameMainName = element.getClassName();
		return mstFrameMainName;
	}

	/**
	 * @param theClass
	 * @return
	 */
	/**
	 * @param theClass
	 * @return
	 */
	private final static boolean isSubClassOfMstFrameMain(final Class<?> theClass) {
		for(Class<?> superClass = theClass; ; superClass = superClass.getSuperclass()){
			if( superClass == MstFrameMain.class)
				return true;
			if(superClass == Object.class)
				return false;
		}
	}

	/**
	 * @param args "Bedeutung" siehe
	 * @link ParamDecoder#main
	 * @param frameMainClass a Class of type MstFrameMain or null
	 *
	 */
	private final static void startMSTAppInternal() {
		MstSecurity.prepare();
		Logger.SWFW.info("Startparameter dieses MstApp [Hauptframe, AppName, Maschine, AppSpez]: " + Arrays.asList(Main.startParameter.originalAppParams).toString(), LMTag.NachSrvTineLog);
		setMstAppK(new MstAppKernel(Main.startParameter));
		UncaughtExceptionHandler.createUncaughtExceptionHandler(getMstAppK());
		//the decoder takes full responsibility of the startup args
		if( Main.startParameter.helpNeeded ){
			//Quick exit due to help request or improper use
			System.out.println(Main.startParameter.helpText());
			JOptionPane.showMessageDialog(null, Main.startParameter.helpText(), "Mst App Help", JOptionPane.INFORMATION_MESSAGE);
			return;
		}

		try {
            mainTreadName = "MstApp " + Main.startParameter.appName + " thread";
            final Class<? extends MstFrame> frameMainClass = getFrameMainClass();
			final Main theMain = new Main(mainTGName);
			final Thread thread = new Thread(theMain, new Runnable() {
				@Override public void run() {
					theMain.myRun(frameMainClass);
				}
			}, mainTreadName);
			thread.start();
		} catch (final ClassNotFoundException e) {
			Logger.SWFW.fatal("Main can not find the class '"
							+ Main.startParameter.mstFrameMainName
							+ "' please check name, classpath, libraries...");
		}
	}

	@SuppressWarnings("unchecked")
	private final static Class<? extends MstFrame>  getFrameMainClass()
												throws ClassNotFoundException{
		return (Class<MstFrame>)Class.forName(Main.startParameter.mstFrameMainName);
	}

//=============================================================================

	private final void myRun(final Class<? extends MstFrame> frameMainClass){
		setLookAndFeel(getLookAndFeel());
		final ParamDecoder sParams = Main.startParameter;
		setFrameFlash(new MstFrameFlash(sParams.appName, sParams.title));
		getFrameFlash().setVisible(true);
		this.progressReceiver = getFrameFlash();
		myRunChoreography(frameMainClass);
	}

	/**only for junit tests*/
	@SuppressWarnings("deprecation") private static boolean iniFiles() {
		return !ParamDecoder._ImplementationSwitches.DEBUGSWITCHES.NOINIFILES.isOn();
	}
	private final void myRunChoreography
							(final Class<? extends MstFrame> frameMainClass) {
        //(1) Initialisation Files
        reserveFlashScreen(true);
        onProgress(Progress.READ_INI_FILES.setStart());
            //assert(getIniFileMgr == null);
            final MasterMgrForIniFiles mgr = new MasterMgrForIniFiles
    					(Main.startParameter.applicationInfo, getMessageMgr());
            if(iniFiles())
            	mgr.readAll();
            else
    			Logger.SWFW.warn("IM JUNIT DEBUG MODUS. No Ini Files are read.");
            setMasterMgrForIniFiles(mgr);//set once
        onProgress(Progress.READ_INI_FILES.setFertig());
        reserveFlashScreen(false);

        //(2)Table Data
        //reserveFlashScreen(true);
        //onProgress(Progress.READ_TABLE_DATA.setStart());
            //Implement Table Data
        //onProgress(Progress.READ_TABLE_DATA.setFertig());
        //reserveFlashScreen(false);

        //(3)mstApp
        this.mstApp = new MstApp(this, Main.startParameter);
        getMstAppK().setMstApp(this.mstApp);
        LoggerManager.setMstApp(this.mstApp);

        //(4)frameMain
        reserveFlashScreen(true);
		onProgress(Progress.FORM_INIT.setStart());
			final MstFrameMain frameMain = createMstFrameMainSubClass
												(frameMainClass, this.mstApp);
			Logger.SWFW_.info(timedMsg(_APPSTART, "Ende der Konstruktion des Hauptfensters."));
			fireAfterFrameCreated(frameMain);
            glueFrameMain(frameMain);
		//onProgress(Progress.FORM_INIT.setFertig());//in fireAfterFrameCreated
        //reserveFlashScreen(false);				 //in fireAfterFrameCreated

		reserveFlashScreen(false);//Creation of FrameFlash

		Logger.SWFW_.info(timedMsg(_APPSTART, "Ende der Initialisierung."), LMTag.NachSrvTineLog);
}

	/**
	 * Extrahiert wegen Lokalitaet von: @SuppressWarnings("deprecation")
	 * @param frameMain, hierauf wird fireAfterFrameCreated() aufgerufen.
	 */
	@SuppressWarnings("deprecation")
	private void fireAfterFrameCreated(final MstFrameMain frameMain) {
		if(frameMain != null) {
			SwingUtilities.invokeLater(
					new Runnable(){
						@Override public void run() {
							frameMain.fireAfterFrameCreated();
							reserveFlashScreen(false);//FORM_INIT
						}
					}
			);
		}
	}

    private final void glueFrameMainWithMsgMgr(final MstFrameMain frameMain, final MessageMgr messageMgr) {
        messageMgr.add(frameMain.getMessageReceiver());
    }

	//returns MstFrameMain frameMain = new MstFrameMain Subclass(mstApp);
	private synchronized final MstFrameMain createMstFrameMainSubClass
		(final Class<? extends MstFrame> frameMainClass, final  MstApp mstApp) {
		final Class<?>[] parameterTypes = {mstApp.getClass()};
		final Object[] params = {mstApp};
		Constructor<?> constructor = null;
		Object frameAsObject = null;
		MstFrameMain frame = null;

		try {
			constructor = frameMainClass.getConstructor(parameterTypes);
			try {
				frameAsObject = constructor.newInstance(params);
								} catch (final IllegalArgumentException ex1) {
									createMstFrameMainSubClassHandleFatalException(frameMainClass, mstApp, ex1);
									return null;
								} catch (final InstantiationException ex1) {
									createMstFrameMainSubClassHandleFatalException(frameMainClass, mstApp, ex1);
									return null;
								} catch (final IllegalAccessException ex1) {
									createMstFrameMainSubClassHandleFatalException(frameMainClass, mstApp, ex1);
									return null;
								} catch (final InvocationTargetException ex1) {
									createMstFrameMainSubClassHandleFatalException(frameMainClass, mstApp, ex1);
									return null;
								}
			frame = (MstFrameMain) frameAsObject;
							} catch (final SecurityException ex) {
									Logger.SWFW.fatal(calcMessage(mstApp, frameMainClass.getName(), ex), ex);
								return null;
							} catch (final NoSuchMethodException ex) {
									Logger.SWFW.fatal(calcMessage(mstApp, frameMainClass.getName(), ex), ex);
								return null;
							}
		Main.lastCreatedFrame  = frame;
		return frame;
	}

	private void createMstFrameMainSubClassHandleFatalException
	(final Class<?> frameMainClass, final IMstAppKernel mstApp, final Exception e) {
//		Logger.SWFW.fatal(calcMessage(mstApp, frameMainClass.getName(), e), e);
		throw new RuntimeException(KONSTRUKOR_PROBLEM, e);
	}

	private String calcMessage(final MstApp mstApp, final String className, final Throwable ex) {
		String retVal;
		if(mstApp.getCreationSuccess() == null){
			retVal =  "Kann die Hauptform '" + className + "' nicht erzeugen."
	            	+ "\nTypische Ursachen:"
		            + "\n   * Hauptform nicht public"
		            + "\n   * Konstruktoren nicht public oder nicht implementiert."
		            + "\n   * Ein Fehler tritt innerhalb des Konstruktors der Klasse auf (Tip: try catch mit Logging):"
		            + "\n      - Passt der Inifile zu der Initialisierung?";
		}else{
			retVal = "Kann die Hauptform '" + className + "' nicht erzeugen."
	               + "Kann aber '" + mstApp.getCreationSuccess() + "' erzeugen."
	               + "\nTypische Ursachen:"
	               + "\n   * Ein Fehler tritt innerhalb des Konstruktors"
	               + " der Klasse auf (Tip: try catch mit Logging):"
	               + "\n      - Passt der Inifile zu der Initialisierung?";

		}
		return 	  retVal;
	}

    /**
     * package private, should only be called by MstApp in case of reverse init for visual editor
     * @throws NullPointerException,  if mgr == null
     * @throws IllegalStateException, if called more than once
     */
    final void setMasterMgrForIniFiles(final MasterMgrForIniFiles mgr) {
        if(mgr == null)                      {throw new NullPointerException ("The mgr may not be null.");}
        if(this.masterMgrForIniFiles != null){throw new IllegalStateException("Tried to set masterMgrForIniFiles twice.");}
        this.masterMgrForIniFiles = mgr;
    }

//=============================================================================

	private static final void processListOnExit() {
		for (final IOnExit iOnExit : listOfOnExits) {
			final String msg = "Error on processing application specifin onExit.";
			try{iOnExit.onExit();}catch(final Exception e){Logger.SWFW.error(msg,e);}
		}
	}

	private final MstFrameFlash getFrameFlash() {return this.frameFlash;}
	private final void setFrameFlash(final MstFrameFlash frameFlash) {
		this.frameFlash = frameFlash;
	}
	private static synchronized MstAppKernel getMstAppK() {return mstAppK;}
	private static synchronized void setMstAppK(final MstAppKernel mstAppK) {
		Main.mstAppK = mstAppK;
	}
	/**best guess only, try to get hold of the one from the MstFrameMain*/
	public static Image getAppImage() {
		final MstFrameMain frame = getLastCreatedFrame();
		if(frame != null)
			return frame.getIconImage();
		return ( new MstImage(Main.getAppName(), Main.class) ).createImage();
	}
}
/**Dummy class for empty  start of library with AL correct about.xml*/
class MstApp11 extends MstFrameMain{
	private static final long serialVersionUID = 1L;  
	@Deprecated public MstApp11() 				{super();}
				public MstApp11(final MstApp mstApp)	{super(mstApp);}
}