/*
 * Created on Jun 14, 2005 - Jun 30, 2005
 *
 */
package de.desy.mst.libs.framework.mstapp.ini;

/**
 * Interface for public registration of external IIniFileObservers
 * @author ws
 * @version 1.0.0
 */
public interface IIniFileObserverRegistrar {
    /**
     * @throws NullPointerException,  falls neuer observer null.
     * */     
    public void registerIniObserver(IIniFileObserver iniObserver);
    public boolean deregisterIniObserver(IIniFileObserver iniObserver);
    
    /** Just for convenience, always register first!*/
    public Object getContentRoot();

}
