/**
 * ws:	May 15, 2007 - May 15, 2007 creation from scratch
 */
package de.desy.mst.libs.framework.mstapp.preferences;

/**
 * Definiert den Speichermode einer Preference.
 * <br> Default ist MEMORYONLY (kein speichern)
 * <br> Implementiert ist noch APPLOCAL (Applikations, User und PC spezifisch)
 * <br> Erweiterungen sind einfach durch weitere Entries konform realisierbar.
 * 
 * @author ws
 * version 1.0.0
 */
public enum PrefSpeicherMode {
	  /**kein Speichern                  */MEMORYONLY
	, /**App, User und PC lokal speichern*/APPLOCAL
	;
//=============================================================================
	  private static final PrefSpeicherMode defaultMode = MEMORYONLY;
//=============================================================================
	  /**never null*/
	  public static final PrefSpeicherMode get_default() {return defaultMode;}
}
