/**
 *  Created on 	Sep 16, 2005 - Sep 16, 2005
 *  			Dec 13, 2005 - Dec 14, 2005	added: getDevNamen()	
 */
package de.desy.mst.libs.framework.mstapp.tabellendaten;

import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.Device;

/**
 * Convenience Klasse fuer Tabellen von Devices.
 * @author ws
 * @version 1.0.0
 */
public class DeviceTabelle<D extends Device> extends Tabelle2<Integer, String, D>  {
	public     DeviceTabelle(final String tabId  ){super(tabId);}
	public final D getDevice(final String devName){return getEntry2(devName);}
	public final D getDevice(final int    devNo  ){return getEntry (Integer.valueOf(devNo));}
	/**never null, but possibly empty*/
	public final String[] getDevNamen()			  {return getSpalteAsStringArray(Device.FIELD_DEV_NAME);}
}
