/*
 *
 * File: ComparatorInt.java
 * Date: Jun 6, 2007; 5:41:44 PM
 */
package de.desy.mst.libs.accelerator;

import java.util.Comparator;

/**
 *
 * @author <a href="mailto:marcus.walla at desy.de">walla</a>
 * @version $Id: ComparatorInt.java 12066 2008-05-29 08:35:57Z walla $
 */
public final class ComparatorInt implements Comparator<Integer>
{

	/**
	 * 
	 */
	public ComparatorInt()
	{
	}

	/*
	 * (non-Javadoc)
	 * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
	 */
	public final int compare(Integer int1_, Integer int2_)
	{
		return int1_ - int2_;
	}
	
	/*
	 * (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override public final boolean equals(Object obj_)
	{
		if (!(obj_ instanceof Integer))
			throw new IllegalArgumentException("The corresponding element" +
					" of object is not an instance of Integer.");
		return obj_.equals(this);
	}

}
/* end of file */