/*
 *
 * File: DESYLogging.java
 * Date: Oct 12, 2006; 3:26:58 PM
 */
package de.desy.mst.libs.accelerator.logging;

import java.util.logging.ConsoleHandler;
import java.util.logging.Formatter;
import java.util.logging.Handler;
import java.util.logging.Logger;

import de.desy.mst.libs.accelerator.CGeneralConstant;
import de.desy.mst.libs.accelerator.LoggerImpl;

/**
 * This class will set the current logging handler for logging information.
 * 
 * @author <a href="marcus.walla at desy.de">walla</a>
 * @version $Id: DESYLogging.java 63634 2014-12-16 12:01:08Z walla $
 * @deprecated Use class {@link LoggerImpl} instead.
 */
@Deprecated
public final class DESYLogging
{

	/** Sets the current logging formatter of the class
	 * {@link de.desy.mst.libs.accelerator.logging.DESYFormatter}. */
	private static final Formatter LOG_FORMATTER = new DESYFormatter();

	/**
	 * This will set miscellaneous parameters for logging information on this
	 * computer. It will set the level and formatter which is stored in the file 
	 * called {@link de.desy.mst.libs.accelerator.CGeneralConstant} as constant  
	 * and static class fields. 
	 */
	@Deprecated
	public static final void createLogging()
	{
		boolean isConsoleHandler = false;
		for(Handler handler: Logger.getLogger("").getHandlers())
		{
			if (handler instanceof ConsoleHandler)
			{
				handler.setFormatter(LOG_FORMATTER);
				handler.setLevel(CGeneralConstant.LOG_LEVEL);
				isConsoleHandler = true;
			}
		}
		if (!isConsoleHandler)
		{
			ConsoleHandler consoleHandler = new ConsoleHandler();
			consoleHandler.setFormatter(LOG_FORMATTER);
			consoleHandler.setLevel(CGeneralConstant.LOG_LEVEL);
			Logger.getLogger("").addHandler(consoleHandler);
		}
	}
}
/* end of file */