/**
 * File: ETabbedPanePlacement.java
 * Date: Feb 3, 2010
 */
package de.desy.mst.libs.accelerator.view;

/**
 * <p>Tabbed pane placement of the tabbed panel selection. Currently this can be 
 * one of the following entries:</p>
 * 
 * <table cellpadding="4" cellspacing="4">
 * 
 * <tr><th>Enumeration Value</th><th>Description</th></tr>
 *
 * <tr bgcolor="#A0A0A0"><td><b>{@link #NON_ROTATED}</b></td><td>Tabbed panels are not rotated.</td></tr>
 * <tr bgcolor="#E0E0E0"><td><b>{@link #ROTATED}</b></td><td>Tabbed panels are rotated.</td></tr>
 * 
 * </table>
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: ETabbedPanePlacement.java 34930 2010-04-11 12:02:20Z walla $
 */
public enum ETabbedPanePlacement
{
	NON_ROTATED, ROTATED;
}
/* end of file */