/*
 * Created on 	May 10, 2005 - Jun 02, 2005
 * 				Oct 25, 2005 - ...	new logging system
 * 				Aug 31, 2007 - Aug 31, 2007	ws: removed calcWebAdr*
 * May  6, 2008 - May  6, 2008	ws: added: 	Time Statistics on isReachable(...)
 * 											UND auskommentiert
 * Aug 27, 2008 - Aug 27, 2008	ws:	added: calcFullFileNameInsideWebServer
 */
package de.desy.mst.libs.framework.mstapp.ini;

import java.net.MalformedURLException;
import java.net.URL;

//import java.io.IOException;
//import java.net.InetAddress;
//import java.net.UnknownHostException;
//import de.desy.mst.libs.framework.mstapp.logging.Logger;


/**
 * All basic WebServer Related stuff, pure static stuff.
 * !careful: PfadeIniDateien has an independend Structure for WebHome for
 * Ini Dateien careful: keep structure changes in synch!!! in doubt use
 * PfadeIniDateien instead
 *
 * @author schuette
 * @version 1.0.0
 */
public final class WebHome {
    private static final String SERVERNAME = "mstweb.desy.de";
    private static final String HTTP_BASE_ADDRESS = "http://" + SERVERNAME + "/";
//    private static final int PINGTIMEOUT = 5000;    //5 Sekunden

//=============================================================================

    /**@return Returns the Http_Base_Address.*/
    public static final String getHttp_Base_Address() {
        return HTTP_BASE_ADDRESS;
    }
    /**@return Returns the ServerName.*/
    public static final String getServerName() {
        return SERVERNAME;
    }

//    /**
//     * @param srvName....like "Ini"
//     * @param appName....application of this webaddress
//     * @param suffix.....like ".xml"
//     * @return
//     */
//    public static final String calcWebAddress(String srvName, String appName, String suffix) {
//        return calcWebAddress(srvName, appName, appName, suffix);
//    }
//    /**
//     * @param srvName....like "Ini"
//     * @param appName....application of this webaddress
//     * @param fileName...name of the file without path and suffix, like "myWebData"
//     * @param suffix.....like ".xml"
//     * @return
//     */
//    public static final String calcWebAddress(String srvName, String appName, String fileName, String suffix) {
//        return (HTTP_BASE_ADDRESS + srvName + "/" + appName + "/" + fileName + suffix);
//    }

    public static boolean isReachable( ){
        return isReachable(WebHome.getServerName());
    }
    /*performance Gruende*/
    public static boolean isReachable(final String serverName){
    	return true;
//    	USE LogUtil.timedMsg instead
//    	final long _start = System.currentTimeMillis();
//        boolean retVal = false;
//        InetAddress inetAddress = null;
//
//        try {
//            inetAddress = InetAddress.getByName(serverName);
//            try {
//                retVal = inetAddress.isReachable(PINGTIMEOUT);
//            } catch (IOException ex) {
//                Logger.Netzwerk.error("'isReachable' @ WebAddress: '" + getServerName() + "' problem:", ex);
//            }
//        } catch (UnknownHostException ex) {
//            Logger.SWFW.error("Unknown WebAddress: '" + getServerName() + "'.", ex);
//        }
//        final String msg = serverName + " ist"
//        				 + (retVal?"":" nicht") + " erreichbar in "
//        				 + (System.currentTimeMillis() - _start) + " ms.";
//		Logger.SWFW_.info(msg);
//        return retVal;
    }

    /**
     * @param webAddress
     * @return the ServerName of the webAddress or exception
     * @throws MalformedURLException, if webAddress is malFormed
     */
    public static String calcServerName(final String webAddress) throws MalformedURLException {
        URL url = new URL(webAddress);
        return url.getHost();
    }
    /**Gives the Windows File Name of the corresponding WebFile*/
	public static String calcFullFileNameInsideWebServer(final String webAddress) {
	//http://mstweb.desy.de/Ini/libs/framework/~Beispiel09_CSVParameterDatei/EditierbareParameterDatei.csv
	//\\Mstweb.desy.de\Ini\libs\framework\~Beispiel09_CSVParameterDatei\EditierbareParameterDatei.csv
		return webAddress.replace("http:", "")
						 .replace("/", "\\");
	}
}
