/**
 *  Created on Oct 24, 2005 - Oct 24, 2005
 *  Jun 05, 2007 - Jun 05, 2007	ws:	added:	format von List<LogMsg>, getHeader()
 */
package de.desy.mst.libs.framework.mstapp.logging;

import java.util.List;

/**
 * Formatierer fuer Logmessages
 * @author ws
 * @version 1.0.0
 */
public interface ILogFormatter {
	/**
	 * Not null, LogMsg wird als ein String ausgegeben
	 *  ohne MultiMessageSeparator
	 */
	public String format(final LogMsg logMsg);
	/**
	 * Not null, eine Liste von LogMsg's werden als ein String ausgegeben. 
	 * Ended mit MultiMessageSeparator
	 */
	public String format(final List<LogMsg> bufferClone);
	/**
	 * Not null, ein einfacher Header typischerweise Spalten Namen<br>
	 * Evtl mit einem MultiMessageSeparator am Ende
	 */
	public String getHeader(final boolean withMultiMessageSeparator);
}
