/**
 * 	Jul 3, 2009 - Jul 3, 2009	ws:	Creation from scratch
 */
package de.desy.mst.libs.framework.mstapp.logging.appender;

/**
 * Interface fuer die Appender. Das objectToBeWritten hat alle Filter passiert
 * und kann jetzt rausgeschrieben werden. Typische Objekt Klassen sind LogMsg,
 * Clog, ...
 * @author ws
 * @version 1.0.0
 */
public interface IWriter<E> {
	/**
	 * Schreibt das objectToBeWritten (Idee filter und hnliche Tests
	 * werden nicht mehr gemacht, nur schlichtes schreiben)
	 * @param  objectToBeWritten may not be null
	 * @throws NullPointerException optional if argument is null
	 */
	public void doWrite(final E objectToBeWritten) throws NullPointerException;
}
