/**
 * May  4, 2009 - May  7, 2009	ws:	Creation from scratch
 */
package de.desy.mst.libs.framework.mstapp.logging.appender.tinelogsrv;

import de.desy.tine.server.logger.ClsLog.ClogPriority;
import de.desy.tine.server.logger.ClsLog.ClogStatus;

/**
 * Fuer Datenhaltung um Tine Loggings erzeugen zu koennen<br>
 * Anwendungen:
 * <li> LogMsgMap ... LogMsg -> Clslog.log(...)
 * <li> TineLogMgr.SystemLogs ... SystemLogs -> Clslog.log(...)
 * @author ws
 * @version 1.0.0
 */
/**pp*/ interface ITineLogInfos {
	public abstract boolean isSystemMsg();

	//log(String text,String context,String tag,String caller,ClogPriority priority,ClogStatus status)
	public abstract String getTText();
	public abstract String getTContext();
	public abstract String getTTag();
	public abstract String getTCaller();
	public abstract ClogPriority getTPriority();
	public abstract ClogStatus   getTStatus();
}