/**
 * ?????????  - ??????????  Wst: creation from scratch
 * 2007-02-06 - 2007-02-13	ws: Anschluss an das System
 */

package de.desy.mst.libs.framework.mstapp.mode;

import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.helper.APrefClientPanelEinfach;
import de.desy.mst.libs.framework.mstapp.preferences.helper.APreferences;

public class PrefServerChoice extends APreferences{
	private static final String[] KEYWORDS = new String[]{"Server", "Simulation"};
	private static final String   TITLE    = "Server Anwahl";
	private final ServerAnwahlMgr serverAnwahlMgr;
	
//=============================================================================
	
	/**
	 * @param serverAnwahlMgr != null
	 * @throws NullPointerException, falls serverAnwahlMgr == null
	 */
	public PrefServerChoice(final ServerAnwahlMgr serverAnwahlMgr) {
		super(TITLE, null, KEYWORDS);
	 	if(serverAnwahlMgr == null) {throw new NullPointerException();}
		this.serverAnwahlMgr = serverAnwahlMgr;
	}
	
//=============================================================================

	@Override public APrefClientPanelEinfach 
					 createPrefClientPanel(final IPrefContainer prefContainer) {
		return new PrefServerChoicePanel(prefContainer, this.serverAnwahlMgr);
	}
} 
