/**
 * 	Jul 14, 2010 - Jul 14, 2010	ws:	created from scratch
 */
package de.desy.mst.libs.info.appadmin;

import java.util.logging.Level;

/**
 * @author ws
 */
class _InternalMsg2UpdateName extends _ATransform<_Msg, String> {

	public _InternalMsg2UpdateName(final _IMsgListener<String> to) {super(to);}

	@Override String transform(final _Msg fromMsg) {
		return isUpdateNotification(fromMsg) ? extractName(fromMsg) 
											 : badMsg(fromMsg);
	}
	//-------------------------------------------------------------------------
	
	private boolean isUpdateNotification(final _Msg message) {
		return message != null 
		    && message.containsByValue(_SystemEntry.UPDATE_NOTIFICATION);
	}
	private String extractName(final _Msg message) {
		return message.getString(_NameEntry._KEY);
	}
	private String badMsg(final _Msg message) {
		_Logging.log(Level.INFO, "Unexpected message: " + message, null);
		return null;
	}
}
