/**
 * 
 * Last changed: $Date$
 * By: $Author$
 * URL: $HeadURL$
 * $Revision$ 
 *
 */
package de.desy.mst.libs.ser.launcher.cache;

/**
 * @author labudda
 *
 */
public interface ICacheItem {

	/**
	 * @return full qualified path of local cached item 
	 */
	public abstract String getCachedItemPath();
	public abstract IStartable getStartable(); 
	/**
	 * @return full qualified path of cached items parent folder
	 */
	abstract String getCachedItemFolder();
	/**
	 * @return True, wenn das Element in den cache kopiert werden konnte.
	 * Ansonsten, insbesondere im Fehlerfall : false 
	 */
	public abstract boolean isAvailable(); 

}