package de.desy.tine.accesslayer;

/**
 * 
 * <code>ConnectionMode</code> defines the possible connection modes to the underlying links.
 * SINGLE connections will receive only one update, CHANGE connections will receive an update
 * every time the value changes, and POLL connections will receive updates periodically.
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 *
 */
public enum ConnectionMode {
    SINGLE, CHANGE, POLL
}
